<?php
/*
Plugin Name: Easy Facebook Share Thumbnail
Plugin URI: http://hebeisenconsulting.com/wordpress-easy-facebook-share-thumbnail/
Description: The post's featured image is used as the thumbnail when the page is being shared on facebook. A default image can also be specified.
Version: 1.8.1
Author: Hebeisen Consulting - R Bueno
Author URI: http://www.hebeisenconsulting.com
License: A "Slug" license name e.g. GPL2

   Copyright 2011 Hebeisen Consulting

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

Thanks to Ryan Hemeon for fixing database prefix bug.
   
                                http://ryan-hemeon.is-a-geek.com/

Wordpress admin settings and core installation
*/

add_action('admin_menu', 'fbthumbnails_menu');
add_action('wp_head', 'fbthumbnails_head');
add_option('fbthumbnails_head_section', '');
add_option('fbthumbnails_link_rel', '');
define('easy_facebook_share_thumbnails_path', ABSPATH . 'wp-content/plugins/easy-facebook-share-thumbnails');
define('easy_facebook_share_thumbnails_url', get_bloginfo('siteurl') . '/wp-content/plugins/easy-facebook-share-thumbnails/thumbnails/');

//Check if featured immage is supported on current theme
//If not, set it on      
if(!function_exists('the_post_thumbnail()')){
	add_theme_support( 'post-thumbnails' ); 
}

//plugin installation
//create ew table upon activating plugin
function fbthumbnails_install()
{
    global $wpdb;
    $table = $wpdb->prefix . "fbthumbnails";
	if($wpdb->get_var("show tables like '$table'") != $table) {
	    $sql = "CREATE TABLE " . $table . " (
					  id int(11) NOT NULL AUTO_INCREMENT,
					  thumbnail varchar(150) NOT NULL,
					  path text NOT NULL,
					  url text NOT NULL,
					  active INT(1) NOT NULL,
					  image_type varchar(10) NOT NULL,
					  PRIMARY KEY (id)
					)";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	    dbDelta($sql);
	}
}

function fbthumbnails_uninstall(){
	global $wpdb;
        $table = $wpdb->prefix . "fbthumbnails";
        
        $wpdb->query("DROP TABLE IF EXISTS $table");
}

register_activation_hook(__FILE__,'fbthumbnails_install');
register_deactivation_hook(__FILE__,'fbthumbnails_uninstall');

//plugin <head></head> overriding
function fbthumbnails_head()
{
	global $wpdb;	
	global $post;
	$table = $wpdb->prefix . "fbthumbnails";
	$post_id = $post;	
	   		//echo $post_id;    
		    if ( is_single($post_id) || is_page($post_id) )
		    {
		    	//print_r( $post );
		    	$post_date = $post_id->post_date;
		    	$post_modified = $post_id->post_modified;
		    	
		    	$post_id = $post_id->ID;
		      	$site_title = get_the_title($post->ID);
		      	$fb_thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($thumbnail->ID, 'thumbnail'));
		      	$post_var = get_post($post_id, ARRAY_A);
		        $raw_content = $post_var['post_content'];		        
			$content = substr( strip_tags($raw_content), 0, strpos( $raw_content, "." ) + 1 );
			//$content = strpos( $raw_content, "." );
	
			 echo "\n";
			 echo "\n";
			 //echo $post_id;
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 //echo "<!-- This is a Post/Page -->";
			 echo "\n";
			 echo '<meta property="og:title" content="'. $site_title . '"/>' . "\n";
			 echo '<meta property="og:type" content="article"/>' . "\n";
			 echo '<meta property="og:url" content="' . get_permalink($post_id->ID) . '"/>' . "\n";		
			 
			 //site name
			 if( get_option( 'esft_site_name' ) != "" ):
			 	echo '<meta property="og:site_name" content="' . get_option( 'esft_site_name' ) . '"/>' . "\n";
			 else:
			 	echo '<meta property="og:site_name" content="' . get_bloginfo('name') . '"/>' . "\n";
			 endif;
			 
			 //app id
			 if( get_option( 'esft_app_id' ) != "" ):
			 	echo '<meta property="fb:app_id" content="' . get_option( 'esft_app_id' ) . '"/>' . "\n";			 
			 endif;
			 
			 //published_time
			 if( get_option( 'esft_published_time' ) != "" ):
			 	echo '<meta property="article:published_time" content="' . $post_date . '"/>' . "\n";			
			 endif;
			 
			 //modified_time
			 if( get_option( 'esft_modified_time' ) != "" ):
			 	echo '<meta property="article:modified_time" content="' . $post_modified . '"/>' . "\n";
			 endif;
			 
			 echo '<meta property="og:description" content="' . $content . '"/>' . "\n";
			 
			 if( has_post_thumbnail($post->ID) ):
			 
			 	//echo "\n";
			 	//echo "<!-- Has Featured Image -->";
			 	//echo "\n";
			 	
			 	echo '<meta property="og:image" content="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			 	echo '<link rel="image_src" href="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			 else:
			 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
			 	if( $active ):
			 		$image = $active['url'];
			 		
			 		//echo "\n";
				 	//echo "<!-- No Featured Image, use Default -->";
				 	//echo "\n";
				 	//echo '<meta property="og:image" content="' . $image . '"/>' . "\n";
				 	//echo '<link rel="image_src" href="' . $image . '"/>' . "\n";
				 	//check mask if other than none
		 			//echo get_option( 'easy_share_mask_type' );
		 			if( get_option( 'easy_share_mask_type' ) == "none" ):
				 		//$image = $active['url'];
				 		
				 		//echo "\n";
					 	//echo "<!-- No Featured Image, use Default -->";
					 	//echo "\n";
					 	echo '<meta property="og:image" content="' . $image . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . $image . '"/>' . "\n";
					 else:
					 	$name = $active['thumbnail'];
					 	echo '<meta property="og:image" content="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 endif;
				 endif;
			 endif;
			 
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 echo "\n";
			 echo "\n";
		    }		    
		    else //if( is_single($post_id) || is_page($post_id))
		    {		 	
		 	//use default image instead
		 	//select active thumbnail in database
		 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
		 	$image = $active['url'];
		 	$post_id = $post_id->ID;
		      	$site_title = get_the_title($post->ID);		      	
		      	$post_var = get_post($post_id, ARRAY_A);
		        $raw_content = $post_var['post_content'];
			$content = substr( strip_tags($raw_content), 0, strpos( $raw_content, "." ) + 1 ); 
		 	 
		 	 echo "\n";
		 	 echo "\n";
		 	 echo "<!-- Easy Facebook Share Thumbnails -->";
		 	 echo "<!-- This is non Post/Page -->";
			 echo "\n";
			 echo '<meta property="og:title" content="'. get_bloginfo('name') . '"/>' . "\n";
			 echo '<meta property="og:type" content="article"/>' . "\n";
			 echo '<meta property="og:url" content="' . get_bloginfo('wpurl') . '"/>' . "\n";
			 
			 if( get_option( 'esft_site_name' ) != "" ):
			 	echo '<meta property="og:site_name" content="' . get_option( 'esft_site_name' ) . '"/>' . "\n";
			 else:
			 	echo '<meta property="og:site_name" content="' . get_bloginfo('name') . '"/>' . "\n";
			 endif;
			 
			 //app id
			 if( get_option( 'esft_app_id' ) != "" ):
			 	echo '<meta property="fb:app_id" content="' . get_option( 'esft_app_id' ) . '"/>' . "\n";			 
			 endif;
			 			 	
			 echo '<meta property="og:description" content="' . get_bloginfo('description') . '"/>' . "\n";
			 //echo get_option( 'easy_share_mask_type' );
			// if( has_post_thumbnail($post->ID) ):
			 	
			 	//echo "\n";
			 	//echo "<!-- Has Featured Image -->";
			 	//echo "\n";
			 
			// 	echo '<meta property="og:image" content="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			// 	echo '<link rel="image_src" href="' . $fb_thumbnail_src[0] . '"/>' . "\n";
			// else:
			 	
			 	$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
		 		if( $active ):
		 		
		 			//check mask if other than none
		 			//echo get_option( 'easy_share_mask_type' );
		 			if( get_option( 'easy_share_mask_type' ) == "none" ):
				 		$image = $active['url'];
				 		
				 		//echo "\n";
					 	//echo "<!-- No Featured Image, use Default -->";
					 	//echo "\n";
					 	echo '<meta property="og:image" content="' . $image . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . $image . '"/>' . "\n";
					 else:
					 	$name = $active['thumbnail'];
					 	echo '<meta property="og:image" content="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 	echo '<link rel="image_src" href="' . easy_facebook_share_thumbnails_url . $name . "-" . get_option( 'easy_share_mask_type' ) . "." . $active['image_type'] . '"/>' . "\n";
					 endif;
				 endif;
			// endif;
			 
			 echo "<!-- Easy Facebook Share Thumbnails -->";
			 echo "\n";
			 echo "\n";

		   }
}

//Wordpress admin menu
function fbthumbnails_menu()
{
	add_options_page('Easy Facebook Share Thumbnails', 'Easy Facebook Share Thumbnails', 'manage_options', 'facebook-thumbnail-slug', 'facebook_thumbnail_option');
}

function easy_facebook_overlay( $image, $image_name, $image_types, $overlay, $output, $overlay_name ){
	//Open two images 
	//determine background file type
	$image_type = exif_imagetype( $image );
	if( $image_type == IMAGETYPE_GIF ):
		$background = imagecreatefromgif( $image );  
	endif;
	
	if( $image_type == IMAGETYPE_PNG ):
		$background = imagecreatefrompng( $image );  
	endif;
	
	if( $image_type == IMAGETYPE_JPEG ):
		$background = imagecreatefromjpeg( $image );  
	endif;
	
	$logo = imagecreatefrompng( $overlay ); 
	
	//Find the size of the PNG 
	$sizepng = getimagesize( $overlay ); 
	$pngw = $sizepng[0]; 
	$pngh = $sizepng[1]; 
	
	$sizejpg = getimagesize( $image ); 
	$placementx = $sizejpg[0] - ($pngw + 0); 
	$placementy = $sizejpg[1] - ($pngh + 0); 

	//Merge two images together 
	imagecopy($background,$logo,0,0,0,0,$pngw, $pngh); 
	//echo $image_type;
	//Output 
	if( $image_type == IMAGETYPE_GIF ):
		imagejpeg($background, $output . "/" . $image_name . "-" . $overlay_name . ".gif"); 
	endif;
	
	if( $image_type == IMAGETYPE_PNG ):
		imagepng($background, $output . "/" . $image_name . "-" . $overlay_name . ".png" , 9); 
	endif;
	
	if( $image_type == IMAGETYPE_JPEG ):
		imagejpeg($background, $output . "/" . $image_name . "-" . $overlay_name . ".jpg" , 100);  
	endif;  
	
}

function facebook_thumbnail_option()
{
	global $wpdb;	
	$table = $wpdb->prefix . "fbthumbnails";
	switch( $_GET['a'] )
		{
			case'delete-thumbnail':
				//delete thumbnail
				//perform deletion
				$wpdb->query("DELETE FROM $table WHERE id = '".$_GET['ID']."'"); 
				echo '<div id="message" class="updated fade"><p>Thumbnail deleted.</p></div>';				
			break;
			case'remove-thumbnail':
				//delete thumbnail
				//perform deletion
				$wpdb->query("UPDATE $table set active = '0' WHERE id = '".$_GET['ID']."'"); 
				echo '<div id="message" class="updated fade"><p>Thumbnail updated.</p></div>';				
			break;
			case'activate-thumbnail':
				//activate thumbnail
				//select current activate thumbnail		
				$active = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);		
				
				//and turn it off
				$wpdb->query( "UPDATE $table SET active = '0' WHERE id = '" . $active['id'] . "'" );
				
				//activate currently selected thumbnail from $_GET['id']
				$wpdb->query( "UPDATE $table SET active = '1' WHERE id = '" . $_GET['ID'] . "'" );
				echo '<div id="message" class="updated fade"><p>Thumbnail Activated.</p></div>';
			break;
			case'change-mask':
				update_option( 'easy_share_mask_type', $_POST['mask_type'] );
			break;
			case'other-settings':
				//other settings
				update_option( 'esft_site_name', $_POST['site_name'] );
				update_option( 'esft_app_id', $_POST['app_id'] );
				update_option( 'esft_published_time', $_POST['published_time'] );
				update_option( 'esft_modified_time', $_POST['modified_time'] );
			break;
			case'add-new-thumbnail':
				
				list($width, $height, $type, $attr) = getimagesize( $_FILES['image']['tmp_name'] );
						
				//check width
				//if greater than 200, stop operation and display error
				//if lower, resize to 200
				
				//if( $width > 200 ):
				//	echo '<div id="message" class="error"><p>Thumbnail size is too large. Make sure it\'s not larger than 200 x 200 pixels.</p></div>';
				//else:				
							
					//image directories
					$upload_dir = wp_upload_dir();
					//add new thumbnail			
					//image name generator
					//use md5 and rand() to generate new image name
					$image_name = md5(rand());
					
					//determine active value
					if($_POST['active'] == ""){
					
					 //not use as default
					 // leave setting as it is
					 $active = "0";
					 
					//validate data
					//if($_POST['thumbnail'] == ""){
					// echo '<div id="message" class="updated fade"><p>Please specify an image. Additionally, your server may not allow uploads. CHMOD the plugin's upload directory to allow uploads..</p></div>';
					//}else{
					 
					 //determine image type
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".gif"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".gif";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".jpeg"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".jpeg";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".png"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".png";
					 // endif;
					 }		  
					  
					  //check file upload if image 
					  if((exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG ))
					  {
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					  			$image_type = "gif";
					  	 
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					  			$image_type = "jpg";
					  			
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					  			$image_type = "png";
					  			
					  			
					  	 //validate image
					  	 //perform operation
						 if(move_uploaded_file($_FILES['image']['tmp_name'], $target_path)) {	
						 
						 //echo easy_facebook_share_thumbnails_path . '/resize_class.php';
						 include easy_facebook_share_thumbnails_path . '/resize_class.php';
						 //echo $target_path;
						 //resize to 200 x 200 pixels
						 //Image resize
						 $resize = new resize( $target_path );							 						 
						 $resize -> resizeImage( 200, 200, 'crop' );						 						 
						 $resize -> saveImage( $target_path , 100);
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "grunge.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "grunge" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "masked.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "masked" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "punch.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "punch" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "rounded.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "rounded" );
						 
						 //insert to database
						 $wpdb->insert( $table, array(
										'thumbnail' => $image_name,
										'path' => $target_path,
										'url' => $url,
										'active' => $active,
										'image_type' => $image_type )
										);
						 //declare success message
						 echo '<div id="message" class="updated fade"><p>Success!.</p></div>';
						 
						 }else{
						 
						 //declare error message
						 echo '<div id="message" class="updated fade"><p>There was an error uploading the file, please try again! Please be sure that the thumbnails folder is writable.</p></div>';
						 
						 }
					  }
					  else
					  {
					  	 
					  	//unrecognised, declare error and stop operation
					   	echo '<div id="message" class="updated fade"><p>File type is not supported. Make sure it is either .PNG, .GIF, .JPEG only.</p></div>';
					  }
					//}
					 
					}else{
					
					//use as default
					//first, deactivate currently used thumbnail
					// then set the new thumbnail as default
					
					//select current activate thumbnail		
					$fbthm = $wpdb->get_row("SELECT * FROM $table WHERE active = '1'", ARRAY_A);
					
					//and turn it off
					$wpdb->query( "UPDATE $table SET active = '0' WHERE id = '" . $fbthm['id'] . "'" );
					
					$active = "1";
					 
					 //validate data
					//if($_POST['thumbnail'] == ""){
					// echo '<div id="message" class="updated fade"><p>Please specify an image. Additionally, your server may not allow uploads. CHMOD the plugin\'s upload directory to allow uploads..</p></div>';
					//}else{
					 
					//determine image type
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".gif"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".gif";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".jpeg"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".jpeg";
					 // endif;
					 }
					 if(exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					 {
					  //check if / present
					  //if( substr( $upload_dir['path'], -1) != "/" ):
					 //	$target_path = $upload_dir['path'] . "/" . $image_name . ".gif"; 
					  //	$url = $upload_dir['url'] . "/" . $image_name . ".gif";
					  //else:
					  	$target_path = easy_facebook_share_thumbnails_path . "/thumbnails/" . $image_name . ".png"; 
					  	$url = easy_facebook_share_thumbnails_url . $image_name . ".png";
					 // endif;
					 }	 
					
					 //check file upload if image 
					  if((exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG ) || (exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG ))
					  {
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_GIF )
					  			$image_type = "gif";
					  	 
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_JPEG )
					  			$image_type = "jpg";
					  			
					  	 if( exif_imagetype($_FILES['image']['tmp_name']) == IMAGETYPE_PNG )
					  			$image_type = "png";
					  			
					  	//validate image
					  	 //perform operation
						 if(move_uploaded_file($_FILES['image']['tmp_name'], $target_path)) {	
						 
						 //echo easy_facebook_share_thumbnails_path . '/resize_class.php';
						 include easy_facebook_share_thumbnails_path . '/resize_class.php';
						 //echo $target_path;
						 //resize to 200 x 200 pixels
						 //Image resize
						 $resize = new resize( $target_path );						 						 
						 $resize -> resizeImage( 200, 200, 'crop' );						 						 
						 $resize -> saveImage( $target_path , 100);
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "grunge.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "grunge" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "masked.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "masked" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "punch.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "punch" );
						 
						 easy_facebook_overlay( $target_path, $image_name, exif_imagetype( $target_path ), easy_facebook_share_thumbnails_path . "/masks/" . "rounded.png", easy_facebook_share_thumbnails_path . "/thumbnails/", "rounded" );
						 
						 //insert database
						 $wpdb->insert( $table, array(
										'thumbnail' => $image_name,
										'path' => $target_path,
										'url' => $url,
										'active' => $active,
										'image_type' => $image_type )
										);
						 //declare success message
						 echo '<div id="message" class="updated fade"><p>Success!.</p></div>';
						 
						 }else{
						 
						 //declare error message
						 echo '<div id="message" class="updated fade"><p>There was an error uploading the file, please try again! Please be sure that the thumbnails folder is writable.</p></div>';
						 
						 }
					  }
					  else
					  {
					  	 
					  	//unrecognised, declare error and stop operation
					   	echo '<div id="message" class="updated fade"><p>File type is not supported. Make sure it is either .PNG, .GIF, .JPEG only.</p></div>';
					  }
					//}
					
					}
				//endif;
			update_option( 'easy_share_mask_type', "rounded" );
			break;
		}
	switch($_GET['page']) {		
		case 'facebook-thumbnail-slug':		
?>
<?php
	
	$record = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $table;"));
		if ( $record != "0" )
			{
?>
		<div class="wrap">
		 <h2>Welcome to Easy Facebook Share Thumbnail</h2>
		 <div class="postbox">
		  <table class="form-table">
		   <tr valign="top" class="alternate">
		    <th scope="row"><label>Thumbnail</label></th><th scope="row"><label>Mask</label></th><th scope="row"><label>Default Thumnail</label></th><th scope="row"><label>Action</label></th>
		   </tr>
<?php

			foreach( $wpdb->get_results("SELECT * FROM $table;") as $key => $row ) {
			// each column in your row will be accessible like this
			$thumbnail = $row->thumbnail;
			$url = $row->url;
			$activate = $row->active;
?>
		    <tr><td><img src = "<?php echo easy_facebook_share_thumbnails_url . $thumbnail . '-rounded.' . $row->image_type; ?>" width = "50px"></td><td><form method="post" action="options-general.php?page=facebook-thumbnail-slug&a=change-mask"><select name="mask_type" <?php if($activate == "1"){ echo ""; }else{ echo "hidden"; } ?>><option value="none" <?php selected( get_option( 'easy_share_mask_type' ), "none" ); ?>>None</option><option value="grunge" <?php selected( get_option( 'easy_share_mask_type' ), "grunge" ); ?>>Grunge</option><option value="masked" <?php selected( get_option( 'easy_share_mask_type'), "masked" ); ?>>Masked</option><option value="punch" <?php selected( get_option( 'easy_share_mask_type'), "punch" ); ?>>Punch</option><option value="rounded" <?php selected( get_option( 'easy_share_mask_type'), "rounded" ); ?>>Rounded</option></select><input type="submit" class="button-primary" value = "Change mask" <?php if($activate == "1"){ echo ""; }else{ echo 'disabled="disabled"'; } ?>></form></td><td><?php if($activate == "1"){ echo "Yes"; } else { echo "No"; }; ?></td><td><input type="submit" class="button-primary" value = "Delete" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=delete-thumbnail&ID=<?php echo $row->id; ?>';"> <?php if($activate == "1") {?><input type="submit" class="button-primary" value = "Unset as default" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=remove-thumbnail&ID=<?php echo $row->id; ?>';"><?php }else{ ?> <input type="submit" class="button-primary" value = "Set as default" onClick = "location.href='options-general.php?page=facebook-thumbnail-slug&a=activate-thumbnail&ID=<?php echo $row->id; ?>';"><?php } ;?></td></tr>
<?php
				}				
?>		   			 	
 		  </table>
 		 </div>
		</div>
		
		<div class="wrap">
		<h2>Thumbnail Mask Sample</h2>
		 <div class="postbox">
 		  <table class="form-table" cellpadding="20">
 		  <tr><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks/roundmask.png' ); ?>"></td><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks/grungesample.png' ); ?>"></td>
 		  </tr>
 		  <tr><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks/roundedsample.png' ); ?>"></td><td><img src="<?php echo plugins_url( '/easy-facebook-share-thumbnails/masks/punchsample.png' ); ?>"></td></tr>
 		  </table>
 		  </div>
 		 </div>
<?php
			}
?>
		<div class="wrap">
		<form method="post" enctype="multipart/form-data" action="options-general.php?page=facebook-thumbnail-slug&a=add-new-thumbnail">
		<input type="hidden" name="" id="info_update1" value="true" />
		 <h2>Upload New Thumbnail</h2>
		 <div class="postbox">
		  <table class="form-table">
		   <!--<tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Thumbnail Name:</label></th><td><input type = "text" name = "thumbnail"></td></tr>-->
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Set To Default. Use this thumbnail for posts without featured images and the home page.:</label></th><td><input type = "checkbox" name = "active"></td></tr>	  
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Image:</label></th><td><input type = "file" name = "image"></td></tr> 
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ></th><td><input type="submit" class="button-primary" value = "Submit"></td></tr> 
		  </table>
		 </div>
		</form>
		</div>
		
		<div class="wrap">
		<form method="post" action="options-general.php?page=facebook-thumbnail-slug&a=other-settings">
		 <h2>Other Settings</h2>
		 <div class="postbox">
		  <table class="form-table">
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Specify Site Name:</label></th><td><input type = "text" name = "site_name" value="<?php echo get_option( 'esft_site_name' ); ?>"></td></tr>
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Specify App ID:</label></th><td><input type = "text" name = "app_id" value="<?php echo get_option( 'esft_app_id' ); ?>"></td></tr>
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Use Published Time Info:</label></th><td><input type = "checkbox" name = "published_time" <?php get_option( 'esft_published_time' ) == "on" ? $chk = "checked" : $chk = ""; echo $chk; ?>></td></tr>	
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ><label>Use Modified Time Info:</label></th><td><input type = "checkbox" name = "modified_time" <?php get_option( 'esft_modified_time' ) == "on" ? $chk = "checked" : $chk = ""; echo $chk; ?>></td></tr>	
		   <tr valign="top" class="alternate"><th scope="row"style="width:32%;" ></th><td><input type="submit" class="button-primary" value = "Submit"></td></tr> 
		   <tr valign="top" class="alternate">
		    <td colspan="2">
		     <label><input value="Debug or validate your pages" type="button" onclick="window.open( 'https://developers.facebook.com/tools/debug' );" ></label> 
		     <label><input value="Generate like button code" type="button" onclick="window.open( 'http://developers.facebook.com/docs/reference/plugins/like/' );" ></label>
		    </td>
		   </tr>
		   <tr valign="top" class="alternate"><td colspan="2"><label><strong>FAQ:<br><br>Q: I have updated the featured image but it is not being reflected when sharing the post on facebook</strong><br>A: When trying out sharing functionality on facebook, your page may be saved or cached in the incorrect manner. If you have been making a number of changes to your post and would like facebook to get a fresh copy, kindly add a random number to your post url instead of the Xs like so:
http://domain.com/this-is-the-post-title/?efs=XXXX
This will trick facebook into thinking that you are sharing a different page, and load up the latest copy (of the same page).<br><br><strong>Q: I have updated the plugin and it stopped working!</strong><br>A: Kindly try and deactivate and reactive the plugin on the Plugins page. If this doesnt work, please make sure that no other facebook function-adding plugins are running alongside this one. <br/><br/> <strong>Q: I cannot seem to upload an image. </strong><br/>A: Be sure that the thumbnails directory in the plugin directory is writable.<br/><br/></label></td></tr>
		  </table>
		 </div>
		</form>
		</div>
		
<?php
		break;
	}
}
?>